

#ifndef DICTIONARYSET_H
#define DICTIONARYSET_H


#include "tdsystem.h"
#include "dictionarybag.h"


/**
  * This class implements the DictionarySet datatype template.
  *
  * @short   Dictionary Set
  * @author  Thomas Dreibholz (dreibh@exp-math.uni-essen.de)
  * @version 1.0
  */    
template<class K, class T> class DictionarySet : public DictionaryBag<K,T>
{
   // ====== Element add/remove functions ===================================
   public:
   /**
     * Add element to head of set, if not already in set.
     *
     * @param key Key of element to be added.
     * @param element Element to be added.
     * @return true, if element has been added; false, if not.
     */
   bool addHead(K key, T element);

   /**
     * Add element to tail of set, if not already in set.
     *
     * @param key Key of element to be added.
     * @param element Element to be added.
     * @return true, if element has been added; false, if not.
     */
   bool addTail(K key, T element);

   /**
     * Add element to set, if not already in set.
     *
     * @param key Key of element to be added.
     * @param element Element to be added.
     * @return true, if the element has been added; false, if not.
     */
   bool add(K key, T element);
};


#include "dictionaryset.icc"


#endif
